<?php
/**
* @file
* @briefQR Code module
* @author   Ruslan Tyan
* @version  3.10.5
* @remarks  Copyright (C) 2010-2021 Ruslan Tyan
* @remarks  Licensed under GNU/GPLv3, see https://www.gnu.org/licenses/gpl-3.0.html
* @see  https://tjan.ru/projects/qrcode
*/
class ModQrcodeHelper
{
public static function getHello($params)
{
function generateCode($length=6) { 
$chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPRQSTUVWXYZ0123456789"; 
$code = ""; 
$clen = strlen($chars) - 1; 
while (strlen($code) < $length) { 
$code .= $chars[mt_rand(0,$clen)]; 
} 
return $code; 
}
function cleanDir($dir) {
$files = glob($dir."/*");
$c = count($files);
if (count($files) > 0) {
foreach ($files as $file) {
if (file_exists($file)) {
unlink($file);
}}}}
$QR_MOD_BASEDIR = dirname(__FILE__).DIRECTORY_SEPARATOR;
$QR_MOD_DIR_MEDIA = JPATH_ROOT.DIRECTORY_SEPARATOR.'media'.DIRECTORY_SEPARATOR.'mod_qrcode'.DIRECTORY_SEPARATOR;
$PNG_TEMP_DIR = $QR_MOD_BASEDIR.'temp'.DIRECTORY_SEPARATOR;
$filenames = generateCode(10).'.png';
$currenturl = JURI::current();
$imgurl = JURI::root().'/modules/mod_qrcode/temp/'.$filenames;
$modurl = JURI::root().'/media/mod_qrcode/';
include $QR_MOD_DIR_MEDIA . 'lib/qr/qrlib.php';
if (file_exists($PNG_TEMP_DIR))
cleanDir($PNG_TEMP_DIR);
if (!file_exists($PNG_TEMP_DIR))
mkdir($PNG_TEMP_DIR);
$filename = $PNG_TEMP_DIR.$filenames;
$errorCorrectionLevel = $params->get('errorCorrectionLevel');
$matrixPointSize = $params->get('matrixPointSize');
$frameLevel = $params->get('frameLevel');
$wh = $params->get('wh');
$cssclass = $params->get('cssclass');
$qrhr = $params->get('qrhr');
$hrcolorl = $params->get('hrcolorl');
$hrcolor = $params->get('hrcolor');
$hrcolorr = $params->get('hrcolorr');
$qrhrimg = $params->get('qrhrimg');
$hrimg = $params->get('hrimg');
$hrcolorimg = $params->get('hrcolorimg');
$hrbcolorimg = $params->get('hrbcolorimg');
$qrhrimgrotate = $params->get('qrhrimgrotate');
$myfontawesome = $params->get('myfontawesome');
$versionfa = $params->get('versionfa');
$mycsshr = $params->get('mycsshr');
$buttonprint = $params->get('buttonprint');
$buttonprintcss = $params->get('buttonprintcss');
$buttonprintcolor = $params->get('buttonprintcolor');
$buttonprintborder = $params->get('buttonprintborder');
$buttonprintcolorhover = $params->get('buttonprintcolorhover');
$buttonprintbackgroundhover = $params->get('buttonprintbackgroundhover');
$buttonprintmycss = $params->get('buttonprintmycss');
$buttonprintborderhover = $params->get('buttonprintborderhover');
$mycssprint = $params->get('mycssprint');
$papermargins = $params->get('papermargins');
$printurl = $params->get('printurl');
$elementsno = $params->get('elementsno');
QRcode::png($currenturl, $filename, $errorCorrectionLevel, $matrixPointSize, $frameLevel);
if ($myfontawesome == 1) { ?>
<link rel="stylesheet" href="<?=$modurl?>lib/fa/css/font-awesome.min.css">
<?php ;} 
if ($myfontawesome == 1 OR $myfontawesome == 0 and $versionfa == 4) {
$fontfamily = 'FontAwesome';
$fontweight = 'normal';
} if ($myfontawesome == 0 and $versionfa == 5) {
$fontfamily = 'Font Awesome 5 Free';
$fontweight = '600';
} if ($myfontawesome == 0 and $versionfa == 6) {
$fontfamily = 'Font Awesome 6 Free';
$fontweight = '900';
} if ($papermargins == 1) {
$margin = '10mm 10mm 10mm 20mm';
} if ($papermargins == 2) {
$margin = '20mm 10mm 20mm 20mm';
} if ($papermargins == 3) {
$margin = '20mm 15mm 20mm 30mm';
} ?>
<style type="text/css">
.myqrcode {
text-align: center;
}
.myqrcode .info {
display: flex;
flex-direction: column;
align-items: center;
padding: 1em;
}
<?php if ($buttonprintcss == 0) { ?>
.myqrcode .info button {
display: inline-block;
font-weight: 400;
color: <?=$buttonprintcolor?>;
-webkit-user-select: none;
-moz-user-select: none;
-ms-user-select: none;
background-color: transparent;
border: 1px solid <?=$buttonprintborder?>;
padding: .375rem .75rem;
margin: 0 0 1em 0;
font-size: 1rem;
line-height: 1.5;
border-radius: .25rem;
}
.myqrcode .info button::before {
font-family: "<?=$fontfamily?>";
font-weight: "<?=$fontweight?>";
font-size: 1rem;
content: "\f02f";
display: inline-block;
padding: 0 .5rem 0 0;
}
.myqrcode .info button:hover {
color: <?=$buttonprintcolorhover?>;
background-color: <?=$buttonprintbackgroundhover?>;
border: 1px solid <?=$buttonprintborderhover?>;
cursor: pointer;
}
<?php ; } ?>
.myqrcode .info img {
display: inline-block;
}
<?php if(!empty($wh)) { ?>
.myqrcode .info img {
width: <?=$wh?>px;
height: <?=$wh?>px;
}
<?php ;} if(!$mycsshr) { ?>
.myqrcode hr {
border: none;
height: 2px;
background-image: linear-gradient(to right, <?=$hrcolorl?>, <?=$hrcolor?>, <?=$hrcolorr?>);
margin: 2em 0;
}
<?php ; } if ($qrhrimg == 1) { ?>
.myqrcode hr::after {
font-family: "<?=$fontfamily?>";
font-weight: "<?=$fontweight?>";
font-size: 1.5em;
content: "<?=$hrimg?>";
display: inline-block;
position: absolute;
color: <?=$hrcolorimg?>;
transform: translate(-50%, -50%) rotate(<?=$qrhrimgrotate?>deg);
transform-origin: 50% 50%;
padding: 1rem;
background-color: <?=$hrbcolorimg?>;
}
<?php ; } if ($mycssprint == 1) { ?>
@import url('https://fonts.googleapis.com/css2?family=Roboto&display=swap');
@media print {
@page {
margin: <?=$margin?>;
}
*,
*::before,
*::after {
color: #000;
box-shadow: none;
text-shadow: none;
font-family: 'Roboto', sans-serif;
}
html,
body {
height: 297mm;
width: 210mm;
font-size: 14px;
}
h1 {
font-size: 24px;
}
h2 {
font-size: 20px;
}
h3 {
font-size: 18px;
}
.wrapper {
width: auto;
margin: 0;
padding: 0;
}
ul,
ol,
table,
button,
hr,
.myqrcode {
page-break-inside: avoid;
}
.noprint {
display: none;
}
<?php if (!empty($elementsno)) { ?>
<?=$elementsno?> {
display: none !important;
}
<?php ;} if ($printurl == 1) { ?>
a[href^="http"]:after {
content: " (" attr(href) ")";
}
<?php ; } ?>
}
<?php ;} ?>
</style>
<div class="myqrcode">
<?php if ($qrhr == 1){ ?>
<hr class="<?=$mycsshr?>" />
<?php ;} ?>
<div class="info">
<?php if($buttonprint == 1){?>
<button onclick="window.print()" 
<?php if ($buttonprintcss == 1) {?>
class="<?=$buttonprintmycss?>"
<?php ;}?>
>Распечатать страницу</button>
<?php ;}?>
<img src="<?=$imgurl?>" alt="QR-код" class="<?=$cssclass?>"/>
</div>
</div>
<?php }}?>